#include <htc.h>
#include "common.h"
#include "ad.h"

#define TLSB	(0.041211)

void ad_init(void)
{
	ADCON1 = 0b00011011;		// -Ref=GND, +Ref=AN3, Use AN3::AN0
	ADCON2 = 0b10000111;		// Right justified, 0TAD, FRC
}

double ad_gettemp(unsigned char ch)
{
	unsigned long val;
	ADCON0 = 0b00000001 + (ch << 2);
	wait_us(100);
	ADCON0 |= 0b00000010;			// Start AD
	while(ADCON0 & 0b00000010) continue;
	ADCON0 = 0;					// Disable AD
	val = (unsigned long)ADRESH << 8 | (unsigned long)ADRESL;

	return ((double)val * (double)TLSB);
}

unsigned long ad_getraw(unsigned char ch)
{
	unsigned long val;
	ADCON0 = 0b00000001 + (ch << 2);
	wait_us(100);
	ADCON0 |= 0b00000010;			// Start AD
	while(ADCON0 & 0b00000010) continue;
	ADCON0 = 0;						// Disable AD
	val = (unsigned long)ADRESH << 8 | (unsigned long)ADRESL;
	return val;
}
