// LCD control function derived from http://www.picfun.com/P12F/p12f05.html
///////////////////////////////////////////////
//  t\퐧֐Q
//    lcd_init()    ----- 
//    lcd_cmd(cmd)  ----- R}ho
//    lcd_data(chr) ----- P\o
//    lcd_clear()   ----- S
//    lcd_str(str)  ----- o
//////////////////////////////////////////////
#include <htc.h>
#include "common.h"
#include "lcd.h"
#define RS	RB0
#define STB	RB1

//////// f[^o̓Tu֐
static void lcd_out(unsigned int data, int flag)
{
	unsigned int tmp;

	tmp = PORTA;				// ςȃoXzuɂȂĂ܂̂
	tmp &= ~0x30;
	tmp |= (data & 0x30);
	PORTA = tmp;

	tmp = PORTC;
	tmp &= ~0xc0;
	tmp |= (data & 0xc0);
	PORTC = tmp;

	if (flag == 0){
		RS = 1;				// \f[^̏ꍇ
	} else {
		RS = 0;				// R}hf[^̏ꍇ
	}
	asm("nop");
	STB = 1;					// strobe out
	asm("nop");
	STB = 0;					// reset strobe
}
//////// P\֐
void lcd_putc(unsigned char c)
{
	lcd_out(c, 0);			// ʂSrbgo
	lcd_out(c<<4, 0);			// ʂSrbgo
	wait_us(50);				// 50sec҂
}
/////// R}ho͊֐
void lcd_cmd(unsigned char cmd)
{
	lcd_out(cmd, 1);			// ʂSrbgo
	lcd_out(cmd<<4, 1);		// ʂSrbgo
	if((cmd & 0x03) != 0){
		wait_ms(2);			// 2msec҂
	} else {
		wait_us(50);			// 50usec҂
	}
}
/////// S֐
void lcd_clear(void)
{
	lcd_cmd(0x01);			// R}ho
	wait_ms(2);				// 2msec҂
}
/////// o͊֐
void lcd_puts(const char *s)
{
	while(*s)				// ̏I蔻
	{
		lcd_putc(*s);			// Po
		s++;					// |C^{P
	}
}
/////// ֐
void lcd_init(void)
{
	wait_ms(15);				// Wait > 15ms after Vcc > 4.5V
	lcd_out(0x30, 1);			// Function set (IF 8bit long)
	wait_ms(5);				// Wait > 4.1ms	
	lcd_out(0x30, 1);			// Function set
	wait_ms(1);				// Wait > 100us
	lcd_out(0x30, 1);			// Function set
	wait_ms(1);
	lcd_out(0x20, 1);			// Function set(4bit mode set)
	wait_ms(1);
	lcd_cmd(0x2E);			// DL=0 4bit mode
	lcd_cmd(0x08);			// display off C=D=B=0
	//lcd_cmd(0x0D);			// display on C=D=1 B=0
	lcd_cmd(0x0C);			// disp ON, Cur=0, Blnk=0;
	lcd_cmd(0x06);			// entry I/D=1 S=0
	lcd_cmd(0x02);			// cursor home
}
